#ifndef __DETECTOR_H
#define __DETECTOR_H

#ifdef __cplusplus
extern "C" {
#endif

/* Header File Including ------------------------------------------------------------------------ */
#include <stdint.h>
#include <stdlib.h>
#include <time.h>
#include "PDRBase.h"
#include "buffer.h"
#include "AHRS.h"

/* Macro Declaration ---------------------------------------------------------------------------- */
#define DETECTOR_NO_ERROR           0
#define DETECTOR_OUT_OF_MEMORY      1
#define MAG_BUF_LEN                 256
#define MAG_LEN                     6

/* Struct Declaration --------------------------------------------------------------------------- */


/* Global Variable Declaration ------------------------------------------------------------------ */
extern BUFFER_SHORT AccFrqBuf[3];
extern BUFFER_SHORT AccAmpBuf[3];
extern BUFFER_SHORT GyrFrqBuf[3];
extern BUFFER_SHORT GyrAmpBuf[3];

/* Function Declaration ------------------------------------------------------------------------- */

/**---------------------------------------------------------------------
* Function    : GetDetectorObj
* Description : ȡPDR˶
* Date        : 2020/02/16 logzhan
*---------------------------------------------------------------------**/
Detector_t *GetDetectorObj(void);

/**---------------------------------------------------------------------
* Function    : Detector_Init
* Description : ʼ˶ʶûһ˶ģʽ
* Date        : 2022/09/23 logzhan 
*---------------------------------------------------------------------**/
Detector_t* Detector_Init(void);

/**---------------------------------------------------------------------
* Function    : DetectorReset
* Description : PDR˶
* Date        : 2022/09/23 logzhan
*---------------------------------------------------------------------**/
void DetectorReset(void);

/**---------------------------------------------------------------------
* Function    : DetectMotionType
* Description : pdr˶ͼ
* Date        : 2020/7/20 
*---------------------------------------------------------------------**/
int DetectMotionType(void);

/**---------------------------------------------------------------------
* Function    : predict
* Description : жֻЯʽֳֵֹ֡ȣ
* Date        : 2020/7/20 logzhan
*---------------------------------------------------------------------**/
int DetectorPredict(float* feature);


/**---------------------------------------------------------------------
* Function    : DetectorUpdateIMU
* Description : ˶ͼimuϢһʱ
*               û˶
* Date        : 2022/09/23
*---------------------------------------------------------------------**/
void DetectorUpdateIMU(IMU_t* imu);

#ifdef __cplusplus
}
#endif

#endif
