/******************** (C) COPYRIGHT 2022 Geek************************************
* File Name          : Filter.c
* Current Version    : V2.0
* Author             : logzhan
* Date of Issued     : 2022.10.15
* Comments           : PDR˲ֿ֧
********************************************************************************/
/* Header File Including ------------------------------------------------------*/
#include "stdio.h"
#include "Filter.h"

/* Function Definition --------------------------------------------------------*/
/**---------------------------------------------------------------------
* Function    : FilterReset
* Description : ˲
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
void FilterReset(Filter_t *f) {
    f->reset = 1;
}

/**---------------------------------------------------------------------
* Function    : FilterSetCoef
* Description : ˲ò
* Input       : order      coefficient array length, not filter order
*               *b         b coefficient
*               *a         a coefficient
*               H0         dc signal gain
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
void FilterSetCoef(Filter_t *f, int order, double *b, double *a, double H0) {
    for (int i = 0; i < order; ++i) {
        f->b[i] = b[i];
        f->a[i] = a[i];
    }
    f->order = order;
    f->H0    = H0;
    f->reset = 1;
}

/**---------------------------------------------------------------------
* Function    : FilterFilter
* Description : ˲˲
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
double FilterFilter(Filter_t *f, double x) {

    if (f->order < 1) {
        printf("fileter order is set to incorrect order, pls chk \
            your code!\n");
        return 0;
    }

    double y = 0.0;
    if (f->reset) {
        for (int i = 0; i < f->order; ++i) {
            f->yout[i] = f->H0 * x;
            f->xin[i] = x;
        }
        y = f->yout[f->order - 1];
        f->reset = 0;
    }
    // push x and y
    for (int i = 0; i < f->order - 1; ++i) {
        f->xin[i] = f->xin[i + 1];
        f->yout[i] = f->yout[i + 1];
    }
    f->xin[f->order - 1] = x;
    // filter
    y = f->b[0] * f->xin[f->order - 1];
    for (int i = 1; i < f->order; ++i) {
        y += f->b[i] * f->xin[f->order - 1 - i] - f->a[i] * f->yout[f->order - 1 - i];
    }
    f->yout[f->order - 1] = y;

    return y / f->H0;
}
