# PDR算法总结

## 一、PDR算法核心优化

​		PDR算法核心优化在于运动学约束。一般的GNSS芯片无法确定物体是如何运动的，所以GNSS芯片也不会对位置预测采取过多的运动学约束。

**1.1 利用IMU对PDR的方向优化**

​		当惯性器件提供的方向比较稳定的时候，我们很容易就利用惯性器件提供的偏航角结合计步器提供的步数对位置进行推算，然后融合GNSS提供的位置，得到最优的位置估计。

**1.2 利用GNSS提供的航向角进行优化**

​		当某些场景，惯性器件无法提供准确的方向的时候，如用户戴着手表跑步的时候。在这类场景中，惯性器件对方向的估计精度就会比较差，这个时候可以利用GNSS提供的航向角进行约束。很多时候，GNSS能够提供不错的航向角的估计，但是位置的估计却没有那么准。如下图所示，红色轨迹是PDR融合轨迹，黄色是GPS原始轨迹。

<img src="./Image/Image-GNSS(1_1).png" alt="image-20221019230229950" style="zoom:50%;" />

<img src="./Image/Image-GNSS_PDR(1_2).png" alt="image-20221019230136833" style="zoom:50%;" />

​		可以看出，黄色的GNSS轨迹提供的航向角是正确的，但是其位置估计却有时候出现运动方向的垂直方向的移动，这个和人体的一般运动学规律不是很符合。红色的GNSS轨迹是采用GNSS航向角进行位置推算得到的PDR轨迹，PDR轨迹总是沿着行人的运动方向推算的，不容易发生突然的横向移动。